//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <cassert>
#include <string>
#include <fstream>
#include <iostream>
#include <sstream>
#include <cmath>

using namespace std;

void Encode(const string& _message, const string& _filename)
{
	ofstream file(_filename.c_str());
	if(!file)
		assert("File creation failed");

	int nChar = _message.length();
	file << nChar;
	assert(file.good());
	file << ' ';
	assert(file.good());
	for(int i=0; i<nChar; ++i)
	{
		int value = static_cast<int>(_message[i]);
		value *= value;
		file << value;
		assert(file.good());
		file << ' ';
		assert(file.good());
	}
}

void Decode(string& _message, const string& _filename)
{	
	ifstream file(_filename.c_str());

	int nChar, value;
	file >> nChar;
	for(int i=0; i<nChar; ++i)
	{
		file >> value;
		assert(file.good());
		value = static_cast<int>(sqrt(static_cast<float>(value)));		
		assert(value>0 && value<255);
		_message += static_cast<char>(value);
	}
}

int main()
{
	string message;
	Encode("helloworld", "crypt.dat");	
	Decode(message, "crypt.dat");
	cout << "Message : " << message << endl;

	char c;
	std::cout << "Press any key, then enter...";
	std::cin >> c;
	return 0; 
}

